.TH NIELD 8 "Oct 11 2010" "nield 0.10" ""
.SH NAME
nield \- Network Interface Events Logging Daemon
.SH SYNOPSIS
.B nield
.B [-vh46inar]
.BI "[\-l " log_file "]"
.BI "[\-d " debug_file "]"

.SH DESCRIPTION
.B NIELD
is the Network Interface Events Logging Daemon. It is possible to receive notifications from kernel through rtnetlink socket and log events related to link state, neighbour cache, IP address, route, fib rules. It can be configured using command-line options.
.SH OPTIONS
The following options are supported. All events are received if any event option not specified.

.TP
Standard options:
.TP
.BR "\-v"
Displays the version and exit.
.TP
.BR "\-h"
Displays the usage and exit.
.TP
.BR "\-l " log_file
Specifies the log file to use. Default is "/var/log/nield.log", if not specified.
.TP
.BR "\-d " debug_file
Specifies the debug file to use.

.TP
Event options:
.TP
.BR "\-4"
Logging events related to IPv4(included link state).
.TP
.BR "\-6"
Logging events related to IPv6(included link state).
.TP
.BR "\-i"
Logging events related to link state including interface name, MAC address, MTU(Maximum Transfer Unit), VLAN(Virtual Local Area Network).
.TP
.BR "\-n"
Logging events related to neigbour cache like ARP(Address Resolution Protocol), NDP(Neighbour Discovery Protocol).
.TP
.BR "\-a"
Logging events related to IP address.
.TP
.BR "\-r"
Logging events related to routing.
.TP
.BR "\-f"
Logging events related to fib rules.
.SH FILES

.nf
/usr/sbin/nield
/var/run/nield.pid
/var/log/nield.log
/usr/share/man/man8/nield.8
.fi
.SH BUGS

If you find bugs or have other suggestions, please contact Tetsumune KISO <t2mune@gmail.com>

.SH "SEE ALSO"

.BR netlink (3),
.BR netlink (7),
.BR rtnetlink (3),
.BR rtnetlink (7)
.SH AUTHORS

.nf
Tetsumune KISO <t2mune@gmail.com>
.fi
