#include "nield.h"

static FILE *log_fd;

/*
 * open a log file
 */
int open_log(char *filename)
{
	log_fd = fopen(filename, "a");
	if(log_fd == NULL) {
		fprintf(stderr, "[ERROR] %s: fopen(): %s\n", __func__, strerror(errno));
		fprintf(stderr, "[ERROR] %s: can't open log file(%s)\n", __func__, filename);
		return(-1);
	}

	return(0);
}

/*
 * record logging messages
 */
void rec_log(char *format, ...)
{
	va_list ap;
	struct timeval tv;
	struct tm *tm;
	char buf[512] = "";
	/* char str[128] = ""; */

	va_start(ap, format);

	vsnprintf(buf, sizeof(buf), format, ap);

	gettimeofday(&tv, NULL);
	tm = localtime(&tv.tv_sec);
	fprintf(log_fd, "%04d-%02d-%02d %02d:%02d:%02d.%06ld %s\n",
		tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
		tm->tm_hour, tm->tm_min, tm->tm_sec, tv.tv_usec, buf);
	/*
	 strftime(str, sizeof(str), "%b %d %X %Y", tm);
	 fprintf(log_fd, "[%s] %s\n", str, buf);
	*/
	fflush(log_fd);

	va_end(ap);
}

/*
 * close a log file
 */
void close_log(void)
{
	if(log_fd)
		fclose(log_fd);
}
