#include "nield.h"

/*
 * debug netlink messages
 */
void debug_nlmsg(struct nlmsghdr *nlh)
{
	/* logging struct nlmsghdr */
	rec_dbg("*********************************************************************");
	rec_dbg("[ nlmsghdr(%d) ]", NLMSG_HDRLEN);
	rec_dbg("    nlmsg_len(%d): %u", sizeof(nlh->nlmsg_len), nlh->nlmsg_len);
	rec_dbg("    nlmsg_type(%d): %hu(%s)",
		sizeof(nlh->nlmsg_type), nlh->nlmsg_type, debug_n2s_nlmsg_type(nlh->nlmsg_type));
	rec_dbg("    nlmsg_flags(%d): %hu", sizeof(nlh->nlmsg_flags), nlh->nlmsg_flags);
	rec_dbg("    nlmsg_seq(%d): %u", sizeof(nlh->nlmsg_seq), nlh->nlmsg_seq);
	rec_dbg("    nlmsg_pid(%d): %u", sizeof(nlh->nlmsg_pid), nlh->nlmsg_pid);

	return;
}

/*
 * convert a netlink message type from number to string
 */
const char *debug_n2s_nlmsg_type(int type)
{
#define _NLMSG_TYPE(s) \
	if(type == RTM_##s) \
		return #s;
	_NLMSG_TYPE(NEWLINK);
	_NLMSG_TYPE(DELLINK);
	_NLMSG_TYPE(GETLINK);
	_NLMSG_TYPE(SETLINK);
	_NLMSG_TYPE(NEWADDR);
	_NLMSG_TYPE(DELADDR);
	_NLMSG_TYPE(GETADDR);
	_NLMSG_TYPE(NEWROUTE);
	_NLMSG_TYPE(DELROUTE);
	_NLMSG_TYPE(GETROUTE);
	_NLMSG_TYPE(NEWNEIGH);
	_NLMSG_TYPE(DELNEIGH);
	_NLMSG_TYPE(GETNEIGH);
	_NLMSG_TYPE(NEWRULE);
	_NLMSG_TYPE(DELRULE);
	_NLMSG_TYPE(GETRULE);
	_NLMSG_TYPE(NEWQDISC);
	_NLMSG_TYPE(DELQDISC);
	_NLMSG_TYPE(GETQDISC);
	_NLMSG_TYPE(NEWTCLASS);
	_NLMSG_TYPE(DELTCLASS);
	_NLMSG_TYPE(GETTCLASS);
	_NLMSG_TYPE(NEWTFILTER);
	_NLMSG_TYPE(DELTFILTER);
	_NLMSG_TYPE(GETTFILTER);
	_NLMSG_TYPE(NEWACTION);
	_NLMSG_TYPE(DELACTION);
	_NLMSG_TYPE(GETACTION);
	_NLMSG_TYPE(NEWPREFIX);
	_NLMSG_TYPE(GETMULTICAST);
	_NLMSG_TYPE(GETANYCAST);
	_NLMSG_TYPE(NEWNEIGHTBL);
	_NLMSG_TYPE(GETNEIGHTBL);
	_NLMSG_TYPE(SETNEIGHTBL);
	_NLMSG_TYPE(NEWNDUSEROPT);
	_NLMSG_TYPE(NEWADDRLABEL);
	_NLMSG_TYPE(DELADDRLABEL);
	_NLMSG_TYPE(GETADDRLABEL);
	_NLMSG_TYPE(GETDCB);
	_NLMSG_TYPE(SETDCB);
#undef _NLMSG_TYPE
}
